/**
 * Binary tree code skeleton.
 *
 * https://www.nada.kth.se/~snilsson/algoritmer/trad/
 *
 * @author Stefan Nilsson
 * @version 2017-02-07
 */
public class BinaryTree {
    private Node root;
    
    private static class Node {
        Node left, right;
        int data;
        
        public Node(int data) {
            this.data = data;
        }

        @Override
        public String toString() {
            return "[" + data + "]";
        }
    }

    /**
     * Creates an empty BinaryTree.
     */
    public BinaryTree() {
    }

    /**
     * Prints a picture of this tree to stdout.
     */
    public void print() {
        printTree(root, 0);
    }

    private void printTree(Node root, int padding) {
        if (root == null) {
            return;
        }
        // Print right subtree.
        printTree(root.right, padding + 1);
        // Print the root:
        for (int i = padding; i > 0; i--) {
            System.out.print("    ");
        }
        System.out.println(root);
        // Print the left subtree.
        printTree(root.left, padding + 1);
    }
    
    // TODO Add find and insert methods (with test code).

    /**
     *
     */
    public static void main(String[] args) {
        BinaryTree t = new BinaryTree();
        t.root = new Node(5);
        t.root.left = new Node(3);
        t.root.right = new Node(8);
        t.root.right.right = new Node(10);
        t.print();
    }
}
